"""
    Open:FactSet Marketplace API

    This API provides read-only access to marketplace products and partners.  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.OpenFactSetMarketplace.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.OpenFactSetMarketplace.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.OpenFactSetMarketplace.model.attributes_groups_item import AttributesGroupsItem
    from fds.sdk.OpenFactSetMarketplace.model.documents_items import DocumentsItems
    from fds.sdk.OpenFactSetMarketplace.model.product_partner import ProductPartner
    from fds.sdk.OpenFactSetMarketplace.model.related_products import RelatedProducts
    from fds.sdk.OpenFactSetMarketplace.model.third_party_urls import ThirdPartyUrls
    globals()['AttributesGroupsItem'] = AttributesGroupsItem
    globals()['DocumentsItems'] = DocumentsItems
    globals()['ProductPartner'] = ProductPartner
    globals()['RelatedProducts'] = RelatedProducts
    globals()['ThirdPartyUrls'] = ThirdPartyUrls


class Product(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('product_status',): {
            'AVAILABLE': "available",
            'CANDIDATE': "candidate",
            'COMINGSOON': "comingSoon",
            'DEVELOPMENTQUEUE': "developmentQueue",
            'NEW': "new",
            'UPDATED': "updated",


        },
        ('type',): {
            'DATAFEED': "dataFeed",
            'API': "api",
            'PLATFORM': "platform",


        },
        ('update_frequency',): {
            'QUARTERLY': "quarterly",
            'MONTHLY': "monthly",
            'DAILY': "daily",
            'WEEKLY': "weekly",
            'ANNUAL': "annual",
            'EVENT': "event",
            'INTRADAY': "intraday",


        },
        ('delivery_frequency',): {
            'INTRADAYDAILY': "intradayDaily",
            'QUARTERLY': "quarterly",
            'MONTHLY': "monthly",
            'INTRADAY': "intraday",
            'WEEKLY': "weekly",
            'DAILY': "daily",
            'ANNUAL': "annual",
            'EVENT': "event",


        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'product_page_url': (str,),  # noqa: E501
            'title': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'create_date': (date,),  # noqa: E501
            'partner': (ProductPartner,),  # noqa: E501
            'product_status': (str,),  # noqa: E501
            'type': ([str],),  # noqa: E501
            'secondary_link': (str,),  # noqa: E501
            'documents': ([DocumentsItems],),  # noqa: E501
            'third_party_urls': ([ThirdPartyUrls],),  # noqa: E501
            'primary_link': (str,),  # noqa: E501
            'preview_link': (str,),  # noqa: E501
            'related_products': ([RelatedProducts],),  # noqa: E501
            'coverage_table': (str,),  # noqa: E501
            'attributes_groups': ([AttributesGroupsItem],),  # noqa: E501
            'video_url': (str,),  # noqa: E501
            'navigator_url': (str,),  # noqa: E501
            'update_frequency': (str,),  # noqa: E501
            'delivery_frequency': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'product_page_url': 'productPageUrl',  # noqa: E501
        'title': 'title',  # noqa: E501
        'description': 'description',  # noqa: E501
        'create_date': 'createDate',  # noqa: E501
        'partner': 'partner',  # noqa: E501
        'product_status': 'productStatus',  # noqa: E501
        'type': 'type',  # noqa: E501
        'secondary_link': 'secondaryLink',  # noqa: E501
        'documents': 'documents',  # noqa: E501
        'third_party_urls': 'thirdPartyUrls',  # noqa: E501
        'primary_link': 'primaryLink',  # noqa: E501
        'preview_link': 'previewLink',  # noqa: E501
        'related_products': 'relatedProducts',  # noqa: E501
        'coverage_table': 'coverageTable',  # noqa: E501
        'attributes_groups': 'attributesGroups',  # noqa: E501
        'video_url': 'videoUrl',  # noqa: E501
        'navigator_url': 'navigatorUrl',  # noqa: E501
        'update_frequency': 'updateFrequency',  # noqa: E501
        'delivery_frequency': 'deliveryFrequency',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, product_page_url, title, description, create_date, partner, product_status, type, *args, **kwargs):  # noqa: E501
        """Product - a model defined in OpenAPI

        Args:
            id (str): Product unique identifier
            product_page_url (str): URL of the product's page on the marketplace catalog.
            title (str): Product title
            description (str): Product description
            create_date (date): Product creation date
            partner (ProductPartner):
            product_status (str): Product status pertaining to its availability on the Open:FactSet Marketplace
            type ([str]): Product type

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            secondary_link (str): Secondary link with additional information. [optional]  # noqa: E501
            documents ([DocumentsItems]): Product documents. [optional]  # noqa: E501
            third_party_urls ([ThirdPartyUrls]): Product third party URLs. [optional]  # noqa: E501
            primary_link (str): Link to primary product information, which is separate from the product's product page URL.. [optional]  # noqa: E501
            preview_link (str): Link to additional information on the product, which is separate from the product's product page URL.. [optional]  # noqa: E501
            related_products ([RelatedProducts]): Related products. [optional]  # noqa: E501
            coverage_table (str): Product coverage table (HTML). [optional]  # noqa: E501
            attributes_groups ([AttributesGroupsItem]): Key-value pairs of product attributes that describe the product and its usage. These attributes groups are used to filter products on the marketplace catalog.. [optional]  # noqa: E501
            video_url (str): Product video URL. [optional]  # noqa: E501
            navigator_url (str): Product Data Navigator URL, on https://open.factset.com/navigator/. [optional]  # noqa: E501
            update_frequency (str): Product update frequency, i.e. 'Daily', 'Weekly', etc.. [optional]  # noqa: E501
            delivery_frequency (str): Product delivery frequency, i.e. 'Daily', 'Weekly', etc.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.product_page_url = product_page_url
        self.title = title
        self.description = description
        self.create_date = create_date
        self.partner = partner
        self.product_status = product_status
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, product_page_url, title, description, create_date, partner, product_status, type, *args, **kwargs):  # noqa: E501
        """Product - a model defined in OpenAPI

        Args:
            id (str): Product unique identifier
            product_page_url (str): URL of the product's page on the marketplace catalog.
            title (str): Product title
            description (str): Product description
            create_date (date): Product creation date
            partner (ProductPartner):
            product_status (str): Product status pertaining to its availability on the Open:FactSet Marketplace
            type ([str]): Product type

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            secondary_link (str): Secondary link with additional information. [optional]  # noqa: E501
            documents ([DocumentsItems]): Product documents. [optional]  # noqa: E501
            third_party_urls ([ThirdPartyUrls]): Product third party URLs. [optional]  # noqa: E501
            primary_link (str): Link to primary product information, which is separate from the product's product page URL.. [optional]  # noqa: E501
            preview_link (str): Link to additional information on the product, which is separate from the product's product page URL.. [optional]  # noqa: E501
            related_products ([RelatedProducts]): Related products. [optional]  # noqa: E501
            coverage_table (str): Product coverage table (HTML). [optional]  # noqa: E501
            attributes_groups ([AttributesGroupsItem]): Key-value pairs of product attributes that describe the product and its usage. These attributes groups are used to filter products on the marketplace catalog.. [optional]  # noqa: E501
            video_url (str): Product video URL. [optional]  # noqa: E501
            navigator_url (str): Product Data Navigator URL, on https://open.factset.com/navigator/. [optional]  # noqa: E501
            update_frequency (str): Product update frequency, i.e. 'Daily', 'Weekly', etc.. [optional]  # noqa: E501
            delivery_frequency (str): Product delivery frequency, i.e. 'Daily', 'Weekly', etc.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.product_page_url = product_page_url
        self.title = title
        self.description = description
        self.create_date = create_date
        self.partner = partner
        self.product_status = product_status
        self.type = type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
